const { build, ajax, utils, view } = require('plm-base');

var handleData = {
    toolbar:utils.loop({
        'undo':'rotate-left',
        'redo':'rotate-right',
        'bold':'bold',
        'italic':'italic',
        'underline':'underline',
        'strikeThrough':'strikethrough',
    },function(v,k){
        this[k] = function(editor){
            this.add('button',{className:'btn btn-xs fa fa-'+v,onclick:function(){
                editor.execCommand(k,false,null)
            }})
        }
    },{
        '|':function(){
            this.add('span',{innerText:'|'})
        },
        'code':function(){
            this.add('button',{className:'btn btn-xs fa fa-code'})
        },
        'header':function(){
            this.add('button',{className:'btn btn-xs fa fa-header'})
        },
        'image':function(){
            this.add('button',{className:'btn btn-xs fa fa-image'})
        },
        'video-camera':function(){
            this.add('button',{className:'btn btn-xs fa fa-video-camera'})
        },
        'createLink':function(editor,last){
            view().add('button',{className:'btn btn-xs fa fa-link',onclick:function(v){
                v.list.look.style.display = v.list.look.style.display == 'none'?'block':'none';
            }}).add('div',{style:{
                position:'absolute',
                width:'300px',
                border:'1px solid #CCC',
                backgroundColor:'#FFF',
                display:'none'
            }},function(){
                this.add('div',{style:{
                    textAlign:'center',
                    width:'100%',
                    backgroundColor:'#EEE',
                },innerText:'标题'}).add('div',{style:{
                    margin:'10px auto',
                    textAlign:'center',
                }},function(){
                    this.add('label',{innerText:'URL:'},function(){
                        this.add('input',{type:'text'}).push('url')
                    }).add('a',{href:'javascript:void(0);',style:{
                        margin:'3px'
                    },innerText:'设置',className:'btn btn-xs btn-default',onclick:function(v){
                        v.list.look.style.display = 'none';
                        editor.view.list.content.focus();
                        editor.backRange();
                        editor.execCommand('createLink',false,v.list.url.value)
                        v.list.url.value='';
                    }})
                })
            }).push('look').render(last)
        }
    })
}
var defaultConfig = {
    toolbar:['code','|','undo','redo','|','header','bold','italic','underline','strikeThrough','|','createLink','image','video-camera']
};
class Editor{
    constructor(content){
        let _this = this;
        this.range = false;
        this.view = view().add('div',function(){
            this.add('div',{className:'plm-editor-header',style:{
                display :'flex',
                backgroundColor: '#F1F1F1',
                border: '1px solid #CCC',
            }},function(){
                utils.loop(defaultConfig.toolbar,function(v){
                    if(typeof handleData.toolbar[v] == 'function') this.add('div',{className:'plm-editor-tool',style:{padding:'5px 10px'}},function(last){
                        handleData.toolbar[v].call(this,_this,last);
                    })
                },this);
            }).add('div',{className:'plm-editor-main',style:{border:'1px solid #CCC'}},function(last){
                this.add('div',{contentEditable:true,className:'plm-editor-content',onblur:function(){
                    _this.keepRange(this);
                },innerHTML:content || '<p><br/></p>',style:{minHeight:'500px'}}).push('content');
            }).add('div',{className:'plm-editor-footer'},function(){
                
            })
        });
    }
    keepRange(dom){
        this.range = window.getSelection().getRangeAt(0);
        return this;
    }
    backRange(){
        window.getSelection().removeAllRanges().addRange(this.range);
        return this;
    }
    execCommand(c,s,a){
        document.execCommand(c,s,a);
        return this;
    }
    render(a,b,c){
        this.view.render(a,b,c);
        return this;
    }
}

module.exports = function(content){
    return new Editor(content);
}