$plm('lazy').css('/assets/css/plm_time.css');
$plm.extend("time",function(tools){
	//如果日期为一位数，则在前面补零
	function fillzero(str){
		var str=typeof str=="string"?str:str.toString();
		if(str.length==1) str="0"+str;
		return str;
	}
	var setDate = function(date,obj){
		if(!obj) obj = {};
		var y = date.getFullYear();
		if(obj.y != y) obj.y = y;
		var m = date.getMonth()+1;
		if(obj.m != m) obj.m = m;
		var d = date.getDate();
		if(obj.d != d) obj.d = d;
		var w = date.getDay();
		if(obj.w != w) obj.w = w;
		var h = date.getHours();
		if(obj.h != h) obj.h = h;
		var i = date.getMinutes();
		if(obj.i != i) obj.i = i;
		var s = date.getSeconds();
		if(obj.s != s) obj.s = s;
		return obj;
	}
	var getDate = function(timestr){
		var t=/(\d+)-(\d+)-(\d+)[T\s]*(\d*):?(\d*):?(\d*)/.exec(timestr);
		if(t) return new Date(t[1],t[2]-1,t[3],t[4],t[5],t[6]);
		return new Date();
	}
	var createDom = function(self){
		return $plm('dom',['div'],self.date)
		.add('div',{className:'datepicker datepicker-dropdown dropdown-menu datepicker-orient-left datepicker-orient-top'},function(){
			this.add('div',{className:'input-group'},function(){
				this.last.style.display = 'table';
				this.last.style.width = '250px';
				this.add('div',{className:'input-group-addon'},function(){
					this.i('fa fa-clock-o glyphicon glyphicon-time')
				}).add('select',{className:'form-control',onchange:function(v){
					self.date.h = this.value
				}},function(h){
					this.add('option',{value:h,innerText:h}).bind('h',function(v){
						this.selected = h==v;
					})
				},24).add('div',{className:'input-group-addon',innerText:':'})
				.add('select',{className:'form-control',onchange:function(v){
					self.date.i = this.value
				}},function(i){
					this.add('option',{value:i,innerText:i}).bind('i',function(v){
						this.selected = i==v;
					})
				},60).add('div',{className:'input-group-addon',innerText:':'})
				.add('select',{className:'form-control',onchange:function(v){
					self.date.s = this.value
				}},function(s){
					this.add('option',{value:s,innerText:s}).bind('s',function(v){
						this.selected = s==v;
					})
				},60)
			}).add('table',{className:'table table-condensed'},function(){
				this.add('thead',function(){
					this.add('tr',function(){
						this.add('th',{className:'prev',onclick:function(){
							self.time.setFullYear(self.date.y - 1);//改变实际年
							setDate(self.time,self.date);//重设所有字符
						}},function(){//上一年
							this.i('fa fa-backward')
						}).add('th',{className:'prev',onclick:function(){
							self.time.setMonth(self.date.m - 2);//改变实际月份
							setDate(self.time,self.date);//重设所有字符
						}},function(){//上个月
							this.i('fa fa-chevron-left glyphicon glyphicon-chevron-left')
						}).add('th',{onclick:function(){
							setDate(new Date(),self.date);//重设所有字符
						},colSpan:3},function(){
							this.add('span').bind('y',function(v){
								this.innerText = v;
							}).add('span',{innerText:'年'}).add('span').bind('m',function(v){
								this.innerText = fillzero(v);
							}).add('span',{innerText:'月'})
						}).add('th',{className:'next',onclick:function(){
							self.time.setMonth(self.date.m);//改变实际月份
							setDate(self.time,self.date);//重设所有字符
						}},function(){//下个月
							this.i('fa fa-chevron-right glyphicon glyphicon-chevron-right')
						}).add('th',{className:'next',onclick:function(){
							self.time.setFullYear(self.date.y+1);//改变实际年
							setDate(self.time,self.date);//重设所有字符
						}},function(){//下一年
							this.i('fa fa-forward')
						})
					}).add('tr',function(k){
						this.add('th',{innerText:k})
					},['日','一','二','三','四','五','六'])
				}).add('tbody').push('body')
			})
		})
	}
	var dateCalendarClass = function(div,input){
		var h=input.offsetHeight;
		var x=input.offsetLeft;
		var y=input.offsetTop;
		while(input=input.offsetParent){
			x+=input.offsetLeft;
			y+=input.offsetTop;
		}
		div.style.left= x+"px";
		div.style.top= y + h + "px";
		div.style.display = 'block';
		div.style.zIndex = 1060;
	}
	var dateModalClass = function(div){
		div.style.position = 'fixed';
		div.style.top = 0;
		div.style.bottom = 0;
		div.style.left = 0;
		div.style.right = 0;
		div.style.zIndex = 1059;
		document.body.appendChild(div);
		div.onclick = function(e){
			if(e.target != div) return;
			document.body.removeChild(div);
		}
	}
	this.init = function(input){
		var self = this;
		self.time = getDate(input.value);//初始化时间对象
		self.date = setDate(self.time);//使用的时间格式化
		self.calendar = createDom(self).push('calendar');//建立dom框
		self.calendar.loop(['y','m','d','h','i','s'],function(v){
			this.bind(v,function(){
				self.time = new Date(self.date.y,self.date.m-1,self.date.d,self.date.h,self.date.i,self.date.s)//重设实际日
				input.value = self.date.y+'-'+fillzero(self.date.m)+'-'+fillzero(self.date.d)+' '+fillzero(self.date.h)+':'+fillzero(self.date.i)+':'+fillzero(self.date.s)//重设输入框时间
			});
		}).bind('m',function(){
			self.format()
		});//监听日期变化则输入框内容变化
		self.format();
		dateCalendarClass(self.calendar.get('calendar'),input);
		dateModalClass(self.calendar.root);
	}
	this.format = function(){
		var self = this;
		var mon = [31,self.date['y']%4==0?29:28,31,30,31,30,31,31,30,31,30,31];//每个月的长度
		var day=1,tm = self.date['m']>=0?self.date['m']-1:0,md = mon[tm],wd=md-self.date['w']+1;//1号,上个月的天数，上个月最后的几天
		self.calendar.move('body',true).loop(6,function(tr){
			if(day > mon[tm]) return;
			this.add('tr',function(td){
				var className = "day";
				if(day == self.date.d) className += " active";
				if(wd<=md) return this.add('td',{className:className+" old",innerText:wd++})
				if(day > mon[tm]) return this.add('td',{className:className+" old",innerText:(wd++)-mon[tm]})
				this.add('td',{className:className,onclick:function(){
					self.date.d = this.innerText;//点击后改变实际日
				},innerText:day++});
			},7)
		})
	}
});
$plm('lazy').define(document.currentScript,function(input){
	$plm('time',input);
});