const { ajax, utils, view } = require('plm-base');
module.exports = class{
    constructor(){
        this.inputs = [];
    }
    input(k, json) {
        if(typeof json != 'object') json = {value:json};
        return this.defaultInput(k,function(dom){
            return view().add('input',utils.merge({type:'text',className:'form-control',value:''},json)).push('body').render(dom,true).list.body;
        })
    }
    date(k,json){
        if(typeof json != 'object') json = {value:json};
        if(typeof json.value == 'string') json.value = json.value.replace(' ','T');
        return this.defaultInput(k,function(dom){
            return view().add('input',utils.merge({type:'datetime-local',className:'form-control',value:'1970-01-01T01:01:01'},json)).push('body').render(dom,true).list.body;
        })
    }
    number(k,json) {
        if(typeof json != 'object') json = {value:json};
        return this.defaultInput(k,function(dom){
            return view().add('input',utils.merge({type:'number',className:'form-control',value:0},json)).push('body').render(dom,true).list.body;
        })
    }
    textarea(k,json) {
        if(typeof json != 'object') json = {value:json};
        return this.defaultInput(k,function(dom){
            return view().add('textarea',utils.merge({className:'form-control',style:{resize:'vertical',height:'120px'},value:''},json)).push('body').render(dom,true).list.body;
        })
    }
    file(k,json) {
        var imageContent = {};
        return this.defaultInput(k,function(dom){
            view().add('input',utils.merge({type:'file',className:'form-control',onchange:function(){
                imageContent.value = this.files[0];
            }},json)).render(dom,true);
            return imageContent;
        })
    }
    select(k, o, vs,json) {
        if(typeof o != 'function'){
            json = vs;
            vs = o;
            o = function(v,k){
                return {value:k,innerText:v};
            }
        }
        return this.defaultInput(k,function(dom){
            return view().add('select', utils.merge({className: 'form-control'},json),function(){
                utils.loop(vs, function (v,key,i) {
                    this.add('option', o(v,key,i));
                }, this);
            }).push('body').render(dom,true).list.body;
        })
    }
    checkbox(k,obj,json){
        json = utils.merge({},json);
        obj = utils.merge(obj,json.def);
        return this.defaultInput(k,function(dom){
            utils.loop(obj,function(value,key){
                this.add('label',{style:{margin:'0 5px'}},function(){
                    this.add('input',{type:'checkbox',checked:value,onchange:function(){
                        obj[key] = this.checked;
                    }}).add('span',{innerText:key})
                })
            },view()).render(dom,true);
            return obj;
        })
    }
    inputGroup(k,inputs,json){
        return this.defaultInput(k,function(dom){
            var form = new Group(json);
            inputs(form);
            form.view.render(dom);
            return form.inputs
        });
    }
    last(callback,json){
        json = utils.merge({},json);
        var _this = this;
        view().add('div',json,function(){
            callback.call(this,_this.inputs);
        }).render(_this.view.list.last || _this.view.root,true)
        return this;
    }
}
class Group extends module.exports{
    constructor(json){
        super();
        this.view = view().add('div', utils.merge({ className: 'input-group' },json)).push('body')
    }
    defaultInput(key, callback){
        var _this = this;
        view().add('span',{className:'input-group-addon',innerText:key}).add('div',function(last){
            _this.inputs.push(callback(last));
        }).render(_this.view.list.body,true);
        return _this;
    }
}