const { view, utils } = require('plm-base');
const Inputs = require('./base.js');
class Modal extends Inputs {
    constructor(title, option) {
        super();
        var _this = this;
        this.option = utils.merge({ className: 'form-group col-lg-12' }, option);
        this.view = view().add('div', { className: 'modal fade in' }, function (last) {
            last.style.display = 'block';
            last.style.overflow = 'auto';
            this.add('div', { className: 'modal-dialog' }, function () {
                this.add('div', { className: 'modal-content' }, function () {
                    this.add('div', { className: 'modal-header' }, function () {
                        this.add('button', {
                            className: 'close', onclick: function () {
                                _this.destroy()
                            }
                        }, function () {
                            this.add('span', { innerText: 'x' });
                        });
                        this.add('h4', { className: 'modal-title', innerText: title })
                    }).add('div', { className: 'modal-body row' }).push('body').push('last');
                }).push('content')
            }).push('dialog');
        }).push('firstRoot');
    }
    defaultInput(key, callback) {
        var _this = this
        view().add('div', this.option, function (last) {
            if (key) this.add('label', { innerText: key });
            _this.inputs.push(callback(last));
        }).render(this.view.list.body, true);
        return this;
    }
    image(k, json) {
        if (typeof json != 'object') json = { src: json };
        json = utils.merge({
            style: {
                width: '100%',
                height: '100%',
                border: "0.5px solid #ccc",
                display: 'block',
                minHeight: '200px'
            }
        }, json)
        var imageContent = { image: json.src, file: json.src, text: json.src, status: 0 };
        this.inputs.push(imageContent);
        Object.defineProperty(imageContent, 'value', {
            get: function () {
                return imageContent.status == 1 ? imageContent.text : imageContent.file;
            }
        });
        view(imageContent).add('div', this.option, function (last) {
            this.add('label', { innerText: k || '' }).add('button', {
                className: 'btn btn-xs btn-info', onclick: function () {
                    imageContent.status = 1 - imageContent.status;
                }, innerText: '转为文字输入', style: { lineHeight: 1, cssFloat: 'right' }
            }).bind('status', function (v) {
                this.className = v == 1 ? 'btn btn-xs btn-warning' : 'btn btn-xs btn-info';
                this.innerText = v == 1 ? '转为图片上传' : '转为文字输入';
            }).add('label', { style: { display: 'block' } }, function () {
                this.add('input', {
                    type: 'file', onchange: function () {
                        if (!this.files[0]) return;
                        imageContent.file = this.files[0];
                        var reader = new FileReader();
                        reader.onload = function () { imageContent.image = this.result; }
                        reader.readAsDataURL(this.files[0]);
                    }, style: { display: 'none' }
                }).add('a', { style: json.style }).bind('image', function (v) {
                    this.style.background = '#FFF url(' + (v || '') + ') no-repeat 0 0/contain';
                })
            }).bind('status', function (v) {
                this.style.display = v == 0 ? 'block' : 'none';
                console.log(this.style.display)
            }).add('input', {
                type: 'text', className: 'form-control', value: json.src || '', oninput: function () {
                    imageContent.value = this.value;
                }, style: { display: 'none' }
            }).bind('status', function (v) {
                this.style.display = v == 1 ? 'block' : 'none';
            })
        }).render(this.view.list.body, true);
        return this;
    }
    images(k, src, json) {
        json = utils.merge({
            style: {
                width: '100px',
                height: '100px',
                border: "0.5px solid #ccc",
                display: 'inline-block',
                margin: '0',
                padding: '0.5px',
                verticalAlign: 'middle',
                textAlign: 'center',
                lineHeight: '100px',
                color: '#CCC',
                fontSize: '50px',
            }
        }, json)
        var imgContent = utils.merge({ src: src, use: src }, { src: [], use: [] });
        Object.defineProperty(imgContent, 'value', {
            get: function () {
                return utils.loop(imgContent.src, function (v, k) {
                    if (imgContent.use[k]) this.push(v);
                }, [])
            }
        })
        this.inputs.push(imgContent);
        view().add('div', this.option, function (last) {
            this.add('label', { innerText: k || '', style: { display: 'block' } }).add('div', function (last) {
                utils.loop(imgContent.src, function (v, key) {
                    this.add('img', {
                        src: v, style: json.style, onclick: function () {
                            if (!window.confirm('确定去除？')) return false;
                            imgContent.use[key] = false;
                            this.style.display = 'none';
                        }
                    })
                }, view()).add('label', utils.merge({ style: json.style, innerHTML: '<i class="fa fa-cloud-upload"></i>' }), function (label) {
                    this.add('input', {
                        type: 'file', onchange: function () {
                            if (!this.files[0]) return;
                            var key = imgContent.src.push(this.files[0]) - 1;
                            var reader = new FileReader();
                            reader.onload = function () {
                                last.insertBefore(utils.build('img', {
                                    src: this.result,
                                    style: json.style,
                                    onclick: function () {
                                        if (!window.confirm('确定去除？')) return false;
                                        imgContent.use[key] = false;
                                        this.style.display = 'none';
                                    }
                                }), label)
                            }
                            imgContent.use[key] = true;
                            reader.readAsDataURL(this.files[0]);
                        }, style: { display: 'none' }
                    })
                }).render(last);
            })
        }).render(this.view.list.body, true);
        return this;
    }
    footer(callback) {
        var _this = this;
        view().add('div', { className: 'modal-footer' }, function () {
            callback.call(this, _this.inputs, function () {
                _this.destroy();
            });
        }).render(_this.view.list.content, true);
        return this;
    }
    render(width) {
        if (width) this.view.list.dialog.style.width = width;
        this.view.render(false, true);
        return this;
    }
    destroy() {
        utils.destroy(this.view.list.firstRoot, true);
        document.body.removeChild(this.view.list.firstRoot);
        return this;
    }
}
module.exports = function (title, defaultClass) {
    return new Modal(title, defaultClass)
}
module.exports.extend = function (a, c) {
    if (Modal.prototype[a]) return console.error('属性' + a + '已存在');
    Modal.prototype[a] = c;
}