const {view,utils} = require('plm-base');
view.extend('button',function(option,innerText,className,other){
    if(typeof option == 'function') option = {onclick:option};
    if(!option) option = {};
    if(!option.innerText) option.innerText = innerText ||'提交';
    if(!option.className) option.className = className || 'btn btn-sm btn-success';
    return this.add('button',option,typeof innerText == 'function'?innerText:other);
});
view.extend('div',function(option,other){
    if(typeof option == 'function') return this.add('div',{},option);
    return this.add('div',option,other);
})
view.extend('a',function(option,other){
    if(typeof option == 'function') return this.add('a',{href:'javascript:viod(0);'},option);
    if(!option) option = {};
    if(!option.href) option.href = 'javascript:viod(0);'
    return this.add('a',option,other);
})
view.extend('i',function(className){
    return this.add('i',{className:className});
})
view.extend('td',function(option,other){
    switch(typeof option){
        case 'function':
        case 'object':
            return this.add('td',option,other);
        case 'string':
            if(other) return this.add('td').bind(option,other);
        default:
            return this.add('td',{innerText:option || ""},other);
    }
})
view.extend('table',function(option,other){
    if(typeof option == 'function') return this.add('table',{className:'table table-bordered'},option);
    return this.add('table',utils.merge({className:'table table-bordered'},option),other);
})
view.extend('thead',function(option,ths){
    if(option instanceof Array){
        ths = option;
        option = {};
    }
    if(typeof option == 'object') option = utils.merge({},option);
    return this.add('thead',option,(typeof ths == 'function')?ths:function(){
        this.add('tr',function(){
            utils.loop(ths,function(e){
                typeof e == 'function' ? this.add('th',e) : this.add('th',{innerText:e});
            },this)
        })
    });
})
view.extend('tbody',function(option,other){
    if(typeof option == 'function') return this.add('tbody',{},option);
    if(typeof option == 'string' && other) return this.add('tbody').bind(option,function(v){
        this.innerHTML = '';
        other.call(this,v);
    });
    return this.add('tbody',utils.merge({},option),other);
})
view.extend('tfoot',function(option,other){
    if(typeof option == 'function') return this.add('tfoot',{},other);
    return this.add('tfoot',utils.merge({},option),other);
})
view.extend('box',function(option,other){
    if(typeof option == 'function') return this.add('div',{className:'box'},option);
    return this.add('div',utils.merge({className:'box'},option),other);
})
view.extend('head',function(option,other){
    if(typeof option == 'function'){
        if(typeof other == 'string') return this.add('div',{className:'box-header with-border'}).bind(other,option);
        return this.add('div',{className:'box-header with-border'},option);
    }
    if(typeof option == 'string') return this.add('div',{className:'box-header with-border'},function(){
        this.add('h3',{className:'box-title',innerText:option}).add('div',{className:'box-tools'},other)
    });
    return this.add('div',utils.merge({className:'box-header with-border'},option),other);
})
view.extend('body',function(option,other){
    if(typeof option == 'function') return this.add('div',{className:'box-body'},option);
    return this.add('div',utils.merge({className:'box-body'},option),other);
})
view.extend('foot',function(option,other){
    if(typeof option == 'function') return this.add('div',{className:'box-footer clearfix'},option);
    if(typeof option == 'string') return this.add('div',{className:'box-footer clearfix'}).bind(option,other);
    return this.add('div',utils.merge({className:'box-footer clearfix'},option),other);
})
view.extend('toolbar',function(option,other){
    if(typeof option == 'function') return this.add('div',{className:'btn-toolbar'},option);
    return this.add('div',utils.merge({className:'btn-toolbar'},option),other);
})
view.extend('input',function(option,value){
    if(typeof option == 'object') return this.add('input',utils.merge({type:'text',className:'form-control',value:value || ''},option));
    if(typeof value == 'string') return this.add('input',utils.merge({type:'text',className:'form-control'})).bind(value,function(v){
        this.value = v===undefined?'':v;
    });
    return this.add('input',{type:'text',className:'form-control',value:option || ''});
})
view.extend('select',function(values,options,option){
    if(typeof options == 'function') return this.add('select',utils.merge({className:'form-control'},option),function(){
        utils.loop(values,function(v,k){
            this.add('option',options(v,k))
        },this)
    })
    return this.add('select',utils.merge({className:'form-control'},options),function(){
        utils.loop(values,function(v,k){
            this.add('option',{value:k,innerText:v})
        },this)
    })
})
view.extend('inputGroup',function(option,other){
    if(typeof option == 'function') return this.add('div',{className:'input-group'},option);
    return this.add('div',utils.merge({className:'input-group'},option),other);
})
view.extend('btnGroup',function(option,other){
    if(typeof option == 'function') return this.add('div',{className:'btn-group'},option);
    return this.add('div',utils.merge({className:'btn-group'},option),other);
})
view.extend('inputGroupSm',function(option,other){
    if(typeof option == 'function') return this.add('div',{className:'input-group input-group-sm'},option);
    return this.add('div',utils.merge({className:'input-group input-group-sm'},option),other);
})
view.extend('span',function(option,other){
    if(typeof option == 'string') return this.add('span',{className:'input-group-addon',innerText:option},other);
    if(typeof option == 'function') return this.add('span',{className:'input-group-addon'},option);
    return this.add('span',utils.merge({className:'input-group-addon'},option),other);
})